The snap-server package

[Tags: bsd3, library]

Snap is a simple and fast web development framework and server written in Haskell. For more information or to download the latest version, you can visit the Snap project website at http://snapframework.com/.

The Snap HTTP server is a high performance, epoll-enabled, iteratee-based web server library written in Haskell. Together with the snap-core library upon which it depends, it provides a clean and efficient Haskell programming interface to the HTTP protocol.

Higher-level facilities for building web applications (like user/session management, component interfaces, data modeling, etc.) are planned but not yet implemented, so this release will mostly be of interest for those who:


[Skip to ReadMe]

Properties

Versions0.1.1, 0.1.2, 0.1.3, 0.1.4, 0.2.1, 0.2.2, 0.2.4, 0.2.5, 0.2.6, 0.2.7, 0.2.7.1, 0.2.7.2, 0.2.8, 0.2.8.1, 0.2.9, 0.2.10, 0.2.10.1, 0.2.10.2, 0.2.11, 0.2.12, 0.2.13, 0.2.13.1, 0.2.13.2, 0.2.13.3, 0.2.14, 0.2.14.1, 0.2.15, 0.2.15.1, 0.2.16, 0.2.16.1, 0.2.16.2, 0.3.0, 0.3.1, 0.3.1.1, 0.4.0, 0.4.0.1, 0.4.0.2, 0.4.1, 0.4.2, 0.4.3, 0.5.0, 0.5.1, 0.5.1.1, 0.5.1.2, 0.5.1.3, 0.5.1.4, 0.5.2, 0.5.3, 0.5.3.1, 0.5.4, 0.5.5, 0.6.0, 0.6.0.1, 0.7, 0.7.0.1, 0.8.0, 0.8.0.1, 0.8.1, 0.8.1.1, 0.9.0, 0.9.2, 0.9.2.1, 0.9.2.2, 0.9.2.3, 0.9.2.4, 0.9.3, 0.9.3.1, 0.9.3.3, 0.9.3.4, 0.9.4.0, 0.9.4.1, 0.9.4.2, 0.9.4.3, 0.9.4.4, 0.9.4.5, 0.9.4.6, 0.9.5.0, 0.9.5.1
Change logNone available
Dependenciesarray (>=0.2 && <0.4), attoparsec (==0.10.*), attoparsec-enumerator (==0.3.*), base (==4.*), binary (==0.5.*), blaze-builder (>=0.2.1.4 && <0.4), blaze-builder-enumerator (>=0.2.0 && <0.3), bytestring (>=0.9.1 && <0.10), bytestring-nums, case-insensitive (>=0.3 && <0.5), containers (>=0.3 && <0.5), directory-tree (==0.10.*), enumerator (>=0.4.13.1 && <0.5), filepath (>=1.1 && <1.3), hlibev (>=0.2.8 && <0.3), HsOpenSSL (==0.10.*), MonadCatchIO-transformers (>=0.2.1 && <0.3), mtl (==2.*), murmur-hash (==0.1.*), network (==2.3.*), old-locale, PSQueue (==1.1.*), snap-core (==0.7.*), template-haskell (>=2.2 && <2.7), text (==0.11.*), time (>=1.0 && <1.5), transformers (==0.2.*), unix, unix-compat (>=0.2 && <0.4), vector (>=0.7 && <0.10), vector-algorithms (>=0.4 && <0.6) [details]
LicenseBSD3
AuthorJames Sanders, Gregory Collins, Doug Beardsley
Maintainersnap@snapframework.com
CategoryWeb, Snap
Home pagehttp://snapframework.com/
Source repositoryhead: git clone git://github.com/snapframework/snap-server.git
UploadedFri Dec 2 01:05:08 UTC 2011 by DougBeardsley
DistributionsDebian:0.9.5.1, Fedora:0.9.4.6, FreeBSD:0.9.5.1, LTSHaskell:0.9.5.1, Stackage:0.9.5.1
Downloads37714 total (939 in last 30 days)
Votes
3 []
StatusDocs uploaded by user
Build status unknown [no reports yet]

Modules

[Index]

Flags

NameDescriptionDefaultType
libevUse libev?DisabledAutomatic
portableCompile in cross-platform mode. No platform-specific code or optimizations such as C routines will be used.DisabledAutomatic
opensslEnable https support using the HsOpenSSL library.DisabledAutomatic

Use -f <flag> to enable a flag, or -f -<flag> to disable that flag. More info

Downloads

Maintainers' corner

For package maintainers and hackage trustees

Readme for snap-server-0.7

Snap Framework HTTP Server Library

This is the Snap Framework HTTP Server library. For more information about Snap, read the README.SNAP.md or visit the Snap project website at http://www.snapframework.com/.

The Snap HTTP server is a high performance, epoll-enabled, iteratee-based web server library written in Haskell. Together with the snap-core library upon which it depends, it provides a clean and efficient Haskell programming interface to the HTTP protocol. Higher-level facilities for building web applications (like user/session management, component interfaces, data modeling, etc.) are not yet implemented, so this release will mostly be of interest for those who:

or

Building snap-server

Dependencies

To build the Snap HTTP server, you need to cabal install the snap-core library (which should have come with this package).

Optional dependencies

The snap-server library can optionally use the libev for high-speed, O(1) scalable socket event processing.

If you would like SSL support, snap-server requires the openssl library.

Building snap-server

The snap-server library is built using Cabal and Hackage. Just run

cabal install

to get the "stock" version of Snap. If you would like to try the optional libev backend, pass the libev flag to cabal install:

cabal install -flibev

And if you would like SSL support, pass the openssl flag to cabal install:

cabal install -fopenssl

Note that the "-flibev" and "-fopenssl" flags are not mutually-exclusive, and if you would like you can use them together.

Building the Haddock Documentation

The haddock documentation can be built using the supplied haddock.sh shell script:

./haddock.sh

The docs get put in dist/doc/html/.

Building the testsuite

The snap-server has a fairly comprehensive test suite. To build and run it, cd into the test/ directory and run

$ cabal configure            # for the stock backend, or..
$ cabal configure -flibev    # for the libev backend, and/or..
$ cabal configure -fopenssl  # for the SSL backend

$ cabal build

From here you can invoke the testsuite by running:

$ ./runTestsAndCoverage.sh 

The testsuite generates an hpc test coverage report in test/dist/hpc.